R_pixel_accuracy = handles.L_peaks{handles.current_L};
N = handles.L_peaks_num(handles.current_L);
S = handles.L_boun{handles.current_L};

Stack_tmp = handles.Stack;

[s1, s2, s3] = size(Stack_tmp);
Pos = []; Sig = []; Int = [];
xy_step = 3;
z_step = 3;
for i=1:N,
    X_cent = R_pixel_accuracy(i, 1);
    Y_cent = R_pixel_accuracy(i, 2);
    Z_cent = R_pixel_accuracy(i, 3);
    
    X_min = X_cent - xy_step;X_max = X_cent + xy_step;
    if X_min < 1, X_min = 1; end
    if X_max > s1, X_max = s1; end
    
    Y_min = Y_cent - xy_step;Y_max = Y_cent + xy_step;
    if Y_min < 1, Y_min = 1; end
    if Y_max > s2, Y_max = s2; end
    
    Z_min = Z_cent - z_step;Z_max = Z_cent + z_step;
    if Z_min < 1, Z_min = 1; end
    if Z_max > s3, Z_max = s3; end
    
    Stack_cut = Stack_tmp(X_min:X_max, :, :);
    Stack_cut = Stack_cut(:, Y_min:Y_max, :);
    Stack_cut = Stack_cut(:, :, Z_min:Z_max);
    
    [Y_mask, X_mask, Z_mask] = meshgrid(Y_min:Y_max, X_min:X_max, Z_min:Z_max);
    
    % Function of drawing the gaussians
    Exp_fun = @(P) P(7)*exp(-((X_mask - P(1))/P(4)).^2).*exp(-((Y_mask - P(2))/P(5)).^2).*exp(-((Z_mask - P(3))/P(6)).^2);
    opt = optimset ( 'Display' , 'off',  'TolX' , 1.e-2 );
    Fit_fun = @(P) sum(sum(sum((Exp_fun(P) - Stack_cut).^2)));
    
    Z_val = Stack_tmp(X_cent, Y_cent, Z_cent);
    P_initial = [X_cent, Y_cent, Z_cent, 1, 1, .5, Z_val];
    
    [P_fit, ~] = fminsearch(Fit_fun, P_initial, opt);
    if P_fit(1) >= X_min && P_fit(1) <= X_max && P_fit(2) >= Y_min && P_fit(2) <= Y_max && P_fit(3) >= Z_min && P_fit(3) <= Z_max,
        Pos = [Pos;P_fit(:, 1:3)];
        Sig = [Sig; P_fit(:, 4:6)];
        Int = [Int;P_fit(:, 7)];
    end
    
end

handles.Bead_fit{handles.current_L} = [Pos, Sig, Int];
