function varargout = Particles_GUI(varargin)
% PARTICLES_GUI MATLAB code for Particles_GUI.fig
%      PARTICLES_GUI, by itself, creates a new PARTICLES_GUI or raises the existing
%      singleton*.
%
%      H = PARTICLES_GUI returns the handle to a new PARTICLES_GUI or the handle to
%      the existing singleton*.
%
%      PARTICLES_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PARTICLES_GUI.M with the given input arguments.
%
%      PARTICLES_GUI('Property','Value',...) creates a new PARTICLES_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Particles_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Particles_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Particles_GUI

% Last Modified by GUIDE v2.5 21-Dec-2011 10:27:52

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Particles_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @Particles_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Particles_GUI is made visible.
function Particles_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Particles_GUI (see VARARGIN)
%{
NOTE: This program requires preprocessing in order to work!
You need to have a bandpassed image stack and a thresholded image stack
saved in the folder DATA_IN.

To generate the bandpassed image stack:
First you must take the 4-D stack of particle images and use a bandpass
filter, either one that you wrote yourself, or through ImageJ.
The parameters for the bankpass filter are usually the following
lower_bound = 1 pixel.
upper_bound = 8-10 pixels.
These bounds may be different depending on the type of image that you are
using.
Save this file in DATA_IN in the following format "filename_BP.tiff"
It is important that it has the string 'BP' in the filename!

To generate the thresholded binary image stack:
Take the bandpassed image stack and threshold it to create a binary image
stack. The threshold you use is up to you, but technically it should
include all the beads and exclude all the noise. It is OK for the beads
to be clumped up.

This algorithm works by first selecting breaking the data into clumps of
beads. Then it loops through all of the clumps, identifies how many 3D
intentisy maximums are in the clump, and then fits that number of gaussian
profiles to the clump.

%}
cd DATA_IN;
dir_tmp = dir;
cd ..;
len = 0;

for i=1:size(dir_tmp, 1),
    
    S_tmp_1 = strfind(dir_tmp(i).name, 'BP');
    S_tmp_2 = strfind(dir_tmp(i).name, 'BW');
    
    if ~isempty(S_tmp_1),
        handles.imfile = [pwd, '/DATA_IN/', dir_tmp(i).name];
        set(handles.BP_file_disp, 'String', dir_tmp(i).name);
    end
    if ~isempty(S_tmp_2),
        handles.bwfile = [pwd, '/DATA_IN/', dir_tmp(i).name];
        set(handles.BW_file_disp, 'String', dir_tmp(i).name);
    end
 
end

% Enter the parameters of the image here:
Td = 149; Zd = 27;
handles.Td = Td; handles.Zd = Zd;

M = imread(handles.imfile, 7);
handles.size = size(M);
handles.Stack = zeros([size(M), Zd]);
handles.BW_stack = zeros([size(M), Zd]);

handles.dx = .323;
handles.dy = .323;
handles.dz = 2.01;

set(handles.slider_t, 'Min', 1);
set(handles.slider_t, 'Max', Td);
set(handles.slider_t, 'Value', 1);
set(handles.slider_t, 'SliderStep', [1/(Td-1) 10/(Td-1)]);

set(handles.slider_z, 'Min', 1);
set(handles.slider_z, 'Max', Zd);
set(handles.slider_z, 'Value', 1);
set(handles.slider_z, 'SliderStep', [1/(Zd-1) 10/(Zd-1)]);

handles.z = get(handles.slider_t, 'Value');
handles.t = get(handles.slider_z, 'Value');
set(handles.t_disp, 'String', ['T: ', num2str(handles.t)]);
set(handles.z_disp, 'String', ['Z: ', num2str(handles.z)]);

if exist('BEADS_DATA.mat', 'file'),
    load('BEADS_DATA.mat');
    handles.Pos_cell = Pos_cell;
    handles.Data_save = Data_save;
    handles.save_exist = save_exist;
    handles.Bead_fit = handles.Data_save{handles.t};
    Make_traj;
else
    handles.Pos_cell = cell(handles.Td, 1);
    handles.Data_save = cell(Td, 1);
    handles.save_exist = zeros(Td, 1);
    
end

    for z = 1:handles.Zd,
        handles.Stack(:, :, z) = double(imread(handles.imfile, handles.t*handles.Zd + z));
        handles.BW_stack(:, :, z) = double(imread(handles.bwfile, handles.t*handles.Zd + z));
    end
    
    
handles.current_L = 1;
set(handles.L_disp, 'String', ['L:' , num2str(handles.current_L)]);
Beads_clumps;
Find_Local_Max;
Disp_image_beads;




set(handles.save_button, 'ForegroundColor', 'g');
set(handles.save_all_button, 'ForegroundColor', 'g');

% Choose default command line output for Particles_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = Particles_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function slider_t_Callback(hObject, eventdata, handles)
handles.z = floor(get(handles.slider_z, 'Value'));
handles.t = floor(get(handles.slider_t, 'Value'));
set(handles.t_disp, 'String', ['T: ', num2str(handles.t)]);

if handles.save_exist(handles.t),
   handles.Bead_fit = handles.Data_save{handles.t};
end

for z = 1:handles.Zd,
    handles.Stack(:, :, z) = double(imread(handles.imfile, handles.t*handles.Zd + z));
    handles.BW_stack(:, :, z) = double(imread(handles.bwfile, handles.t*handles.Zd + z));
end

handles.current_L = 1;
Beads_clumps;
Find_Local_Max;
Disp_image_beads;
guidata(hObject, handles);

% --- Executes on slider movement.
function slider_z_Callback(hObject, eventdata, handles)
handles.z = floor(get(handles.slider_z, 'Value'));
handles.t = floor(get(handles.slider_t, 'Value'));
set(handles.z_disp, 'String', ['Z: ', num2str(handles.z)]);
Disp_image_beads;
guidata(hObject, handles);

function slider_L_Callback(hObject, eventdata, handles)
handles.current_L = floor(get(handles.slider_L, 'Value'));
set(handles.size_disp, 'String', num2str(handles.L_sizes(handles.current_L)));
set(handles.Peaks_num_disp, 'String', num2str(handles.L_peaks_num(handles.current_L)));
handles.z = floor((handles.L_boun{handles.current_L}(6) + handles.L_boun{handles.current_L}(5))/2);
set(handles.slider_z, 'Value', handles.z);
set(handles.z_disp, 'String', ['Z: ', num2str(handles.z)]);
set(handles.L_disp, 'String', ['L:' , num2str(handles.current_L)]);
Disp_image_beads;
guidata(hObject, handles);

% --- Executes on button press in Delete_button.
function Delete_button_Callback(hObject, eventdata, handles)
handles.Stack(handles.L == handles.current_L) = 0;
handles.BW_stack(handles.L == handles.current_L) = 0;
handles.current_L = handles.current_L - 1;

Beads_clumps;
Disp_image_beads;
guidata(hObject, handles);

function fit_gauss_Callback(hObject, eventdata, handles)
Fit_gaussians;
Disp_image_beads;
guidata(hObject, handles);

function gauss_fit_all_button_Callback(hObject, eventdata, handles)
cur_L_tmp = handles.current_L;
for i_loop = 1:handles.Num,
    handles.current_L = i_loop;
    Fit_gaussians;
end
handles.current_L = cur_L_tmp;
Disp_image_beads;

guidata(hObject, handles);


function proc_all_button_Callback(hObject, eventdata, handles)
% This is for the gaussian fit method
Process_All;
% This is for the matrix division fit method
%Process_All_2;


Pos_cell = handles.Pos_cell;
Data_save = handles.Data_save;
save_exist = handles.save_exist;
cd DATA_OUT;
save BEADS_DATA Pos_cell Data_save save_exist;
cd ..;
guidata(hObject, handles);

function filter_small_Callback(hObject, eventdata, handles)
filter_small = str2num(get(handles.enter_size, 'String'));

for i=1:handles.Num,
   if handles.L_sizes(i) <= filter_small,
       handles.Stack(handles.L == i) = 0;
       handles.BW_stack(handles.L == i) = 0;
   end
end
handles.current_L = 1;
Beads_clumps;
Disp_image_beads;
guidata(hObject, handles);

function save_all_button_Callback(hObject, eventdata, handles)
Nucleus_data = handles.Data_save;
save_exist = handles.save_exist;
save Nucleus_GUI_data Nucleus_data save_exist;
set(handles.save_all_button, 'ForegroundColor', 'g');
guidata(hObject, handles);

% --- Executes on button press in save_button.
function save_button_Callback(hObject, eventdata, handles)
handles.Data_save{handles.t} = handles.Stack;
handles.save_exist(handles.t) = 1;
set(handles.save_button, 'ForegroundColor', 'g');
guidata(hObject, handles);




% --- Executes during object creation, after setting all properties.
function slider_t_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes during object creation, after setting all properties.
function slider_z_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



% --- Executes during object creation, after setting all properties.
function slider_L_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_L (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on mouse press over axes background.
function axes1_ButtonDownFcn(hObject, eventdata, handles)
disp('Helllo');
guidata(hObject, handles);

function enter_size_Callback(hObject, eventdata, handles)
% hObject    handle to enter_size (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of enter_size as text
%        str2double(get(hObject,'String')) returns contents of enter_size as a double


% --- Executes during object creation, after setting all properties.
function enter_size_CreateFcn(hObject, eventdata, handles)
% hObject    handle to enter_size (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
