
% Create the basis that will be used to analyze the beads

Sigma_X = .05; Sigma_Y = .05; Sigma_Z = .3;

Kx = 70; Ky = 70; Kz = 26; 






for t = 1:handles.Td
    % Change time
    handles.t = t;
    set(handles.t_disp, 'String', ['T: ', num2str(handles.t)]);

    set(handles.slider_t, 'Value', t);
    pause(.1);
    
    % Read in the stack for the new time
    if handles.save_exist(handles.t),
        handles.Stack = handles.Data_save{handles.t};
    else
        for z = 1:handles.Zd,
            handles.Stack(:, :, z) = double(imread(handles.imfile, handles.t*handles.Zd + z));
            handles.BW_stack(:, :, z) = double(imread(handles.bwfile, handles.t*handles.Zd + z));
        end
    end
    handles.current_L = 1;
    
    % Filter the small ones
    [handles.L, handles.Num] = bwlabeln(handles.BW_stack, 6);
    set(handles.progress_disp, 'String', ['Filtering for T = ', num2str(t)]);
    filter_small = str2num(get(handles.enter_size, 'String'));
    for k=1:handles.Num,
        if sum(sum(sum(handles.L == k))) <= filter_small,
            handles.Stack(handles.L == k) = 0;
            handles.BW_stack(handles.L == k) = 0;
        end
    end
    
    [handles.L, handles.Num] = bwlabeln(handles.BW_stack, 6);
    set(handles.progress_disp, 'String', ['Fitting T = ', num2str(t)]);
    pause(.03);
    
    % Now loop over each object and use the matrix division algorithm
    for i_loop = 1:handles.Num,
        % Find the limits
        Id_th = find(handles.L == i_loop); %% find all the points that are larger than th;
        
        Id_prime = Id_th-1;
        Z_th = floor(Id_prime/(s1*s2))+1;
        Y_th = floor(mod(Id_prime, s1*s2)/s1)+1;
        X_th = mod(Id_prime, s1) +1;
        
        X_min = min(X_th) - 1;X_max = max(X_th) + 1;
        if X_min < 1, X_min = 1; end
        if X_max > s1, X_max = s1; end
        
        Y_min = min(Y_th) - 1;Y_max = max(Y_th) + 1;
        if Y_min < 1, Y_min = 1; end
        if Y_max > s2, Y_max = s2; end
        
        Z_min = min(Z_th) - 1;Z_max = max(Z_th) + 1;
        if Z_min < 1, Z_min = 1; end
        if Z_max > s3, Z_max = s3; end
    end
    
    
    
    
    % Create the basis
    x_step = 3;
    y_step = 3;
    z_step = 3;
    N = x_step*y_step*z_step;
    
    k_x
    
    % Process the data
    Pos_cell_tmp = [];
    for i_loop = 1:handles.Num,
        handles.current_L = i_loop;
        set(handles.progress_disp, 'String', ['Fitting T = ', num2str(t), ' and L = ', num2str(i_loop), '/', num2str(handles.Num)]);
        pause(.03);
        Fit_Matrix_method;
        Pos_cell_tmp = [Pos_cell_tmp;Pos];
    end
    set(handles.progress_disp, 'String', ['Done Processing T = ', num2str(t)]);
    pause(.03);
    handles.Data_save{t} = handles.Bead_fit;
    handles.Pos_cell{t} = Pos_cell_tmp;
    handles.save_exist(t) = 1;
    disp(['Done for t = ', num2str(t)]);

end
