clear all;
close all;
clc;

%% Test of Papa's method for one dimension
N = 100;
X = linspace(-5, 5, N);
dx = X(2) - X(1);
X_0 = -1.467;
X_0_2 = 1.237;
Y = exp(-(X - X_0).^2) + exp(-(X - X_0_2).^2);

%%
K = 25; % The number of basis vectors

X_C = linspace(-5, 5, K)';
X_B = repmat(X, K, 1) - repmat(X_C, 1, N);
B = exp(-X_B.^2);

%%

C = Y/B;
figure, hold on;
plot(X, Y, 'b');
plot(X_C, C, 'r');
plot(X, C*B, 'g');
title('Original Data and fit');

figure, hold on;
for i=1:K,
    plot(B(i, :));
end
title('Basis');

disp(['The original peak is at ', num2str(X_0)]);

disp(['The determined peak is at ', num2str(mean(-C*X_B))]);




