close all;
clear all;
clc;

%% Same as Test but 2D
Nx = 10;
Ny = 10;
N = Nx*Ny;

[X, Y] = meshgrid(linspace(-5, 5, Nx), linspace(-5, 5, Ny));
X = reshape(X, N, 1);
Y = reshape(Y, N, 1);


X_0 = 1.2; Y_0 = -2.45;
Z_M = zeros(1, Nx, Ny);
Z = exp(-((X - X_0).^2 + (Y - Y_0).^2));
Z_tmp = reshape(Z, Nx, Ny);
figure, surf(Z_tmp), shading interp;
%%
% Create the basis
K_X = 5; K_Y = 5;
K = K_X*K_Y;
dx = 10/(K_X-1);dy = 10/(K_Y-1);
B = zeros(K, N);
id = 1;
X_C = []; Y_C = [];
for i=1:K_X,
    for j = 1:K_Y,
        X_offset = -5 + (i-1)*dx;
        Y_offset = -5 + (j-1)*dy;
       B(id, :) = exp(-((X - X_offset).^2 + (Y - Y_offset).^2));
       id = id + 1;
       X_C = [X_C;X_offset]; Y_C = [Y_C;Y_offset];
    end
end

%%
tic,
C = Z'/B;
toc;
C_tmp = reshape(C, K_X, K_Y);
figure, surf(C_tmp), shading interp;

