function [Id_out] = Trace_Part_k(S1, S2)
%TRACE_PART_K Summary of this function goes here


%%
%  First connect the particle with its closest neighbor
if size(S1, 1) == 0 || size(S2, 1) == 0,
    Id_out = [];
    return;
end

Id = zeros(size(S1, 1), 2);
for i=1:size(S1, 1),
    % Find the distances between particle 
    R = sqrt((S2(:, 1) - S1(i, 1)).^2 + (S2(:, 2) - S1(i, 2)).^2 + (S2(:, 3) - S1(i, 3)).^2);
    Id(i, 2) = find(R == min(R), 1);
    Id(i, 1) = i;
end
%%
% Now Check that there are particles that are doubling up


Id_sort = sort(Id(:, 2));
Check = diff(Id_sort);
% Get the indices of all points that had more than one arrival
Doubles = Id_sort(Check == 0);
if size(Doubles, 1) ~= 0,
    Doubles = Doubles([1;diff(Doubles)]>0);
end
%% Now first build Id_out wothout any doubles
    Id_out = [];

if size(Doubles, 1) ~= 0,
    for j=1:size(Id, 1),
        if sum(Id(j, 2) == Doubles) == 0,
            Id_out = [Id_out;Id(j, :)];
        end
    end
    
    % And now loop through doubles and pick the closest
    for j=1:length(Doubles),
        Id_d = Id(Id(:, 2) == Doubles(j), 1);
        R_d1 = S1(Id_d, :);
        R_d2 = S2(Doubles(j), :);
        R = sqrt((R_d1(:, 1) - R_d2(:, 1)).^2 + (R_d1(:, 2) - R_d2(:, 2)).^2 + (R_d1(:, 3) - R_d2(:, 3)).^2);
        Id_tmp = Id_d(find(R == min(R), 1));
        Id_out = [Id_out;[Id_tmp, Doubles(j)]];
    end
else
    Id_out = Id;
end




end

