function [Tri_cell] = Triangular_Trace(Pos_cell)
%TRIANGULAR_TRACE Loops through all the particles and collects all of the
%triangularized trajectories

T_end = length(Pos_cell)-2;
Tri_cell = cell(1, T_end);
for t=1:T_end,
   S1 = Pos_cell{t};
   S2 = Pos_cell{t+1};
   S3 = Pos_cell{t+2};
   %%{
    Id12e = Trace_Part_k(S1, S2);
    Id23e = Trace_Part_k(S2, S3);
    Id13e = Trace_Part_k(S1, S3);
    %}
    %{
    Id12e = Track_t(S1, S2);
    Id23e = Track_t(S2, S3);
    Id13e = Track_t(S1, S3);
    %}
    P_tmp = 0;
    ID_check = zeros(size(Id12e));
    if size(Id12e, 1) > 0 && size(Id13e, 1) > 0 && size(Id23e, 1) > 0
        for i=1:size(Id12e, 1),
            % First check if the particle is in the set of Id12e and Id23
            Index1 = find(Id13e(:, 1) == Id12e(i, 1), 1);
            Index2 = find(Id23e(:, 1) == Id12e(i, 2), 1);
            if ~isempty(Index1) && ~isempty(Index2),
                % If particle movement from t to t+2 is the same as t to t+1 to t+2
                if (Id13e(Index1, 2) == Id23e(Index2, 2)),
                    % Then count it
                    P_tmp = P_tmp+1;
                    % and mark it
                    ID_check(i) = 1;
                end
            end
            
        end
   %disp(['The triangles correspond to %', num2str(floor(100*P_tmp/size(Id12e, 1)))]);
   % Select only the marked particles
        Tri_cell{t} = Id12e(ID_check > 0, :);
    else
        Tri_cell{t} = [];
    end
end



end

