function [All_P] = gaussfit3_no_cut(R, Z_crazy, sz, dx, dy, dz)
%[X_fit, Y_fit, Z_fit, All_P] = gaussfit3(R, Z_crazy, sz, dx, dy, dz)
%GAUSSFIT3 Summary of this function goes here
%   Detailed explanation goes here
% R is the position of the particles
% Z_crazy is the bypassed image


if size(R, 2) ~= 3,
    disp('ERROR:  R must be 3 colums');
    All_P = [];
    return;
end
X_fit = []; Y_fit = []; Z_fit = [];All_P = [];

close all;

[s1, s2, s3] = size(Z_crazy);

for i=1:size(R, 1),
    
    xtmp = R(i, 1);
    ytmp = R(i, 2);
    ztmp = R(i, 3);
    
    
    if xtmp <= sz,
        idx1 = 1; idx2 = xtmp+sz;
    elseif xtmp >= (s1-sz),
        idx1 = xtmp-sz; idx2 = s1;
    else
        idx1 = xtmp-sz; idx2 = xtmp+sz;
    end
    
    if ytmp <= sz,
        idy1 = 1; idy2 = ytmp+sz;
    elseif ytmp >= (s2-sz),
        idy1 = ytmp-sz; idy2 = s2;
    else
        idy1 = ytmp-sz; idy2 = ytmp+sz;
    end
    
    if ztmp <= sz,
        idz1 = 1; idz2 = ztmp+sz;
    elseif ztmp >= (s3-sz),
        idz1 = ztmp-sz; idz2 = s3;
    else
        idz1 = ztmp-sz; idz2 = ztmp+sz;
    end
    
    X_mask = (idx1:idx2)';
    Y_mask = (idy1:idy2)';
    Z_mask = (idz1:idz2)';
    
    X_tmp = squeeze(Z_crazy(idx1:idx2, ytmp, ztmp)); 
    Y_tmp = squeeze(Z_crazy(xtmp, idy1:idy2, ztmp))';
    Z_tmp = squeeze(Z_crazy(xtmp, ytmp, idz1:idz2));
    
    if length(X_mask) ~= length(X_tmp),
        disp('WTF');
    end
    
    if length(Y_mask) ~= length(Y_tmp),
        disp('WTF');
    end
    
    if length(Y_mask) ~= length(Y_tmp),
        disp('WTF');
    end
    
   G_x = @(Px) sum( (Px(3)*exp(-((Px(1) - X_mask)/Px(2)).^2) - X_tmp).^2);
   G_y = @(Py) sum( (Py(3)*exp(-((Py(1) - Y_mask)/Py(2)).^2) - Y_tmp).^2);
   G_z = @(Pz) sum( (Pz(3)*exp(-((Pz(1) - Z_mask)/Pz(2)).^2) - Z_tmp).^2);
        
              
                
    Z_val = Z_crazy(xtmp, ytmp, ztmp);
                
                             
                

                
	[Px_fit, fval] = fminsearch(G_x, [R(i, 1), 1, Z_val]);
	[Py_fit, fval] = fminsearch(G_y, [R(i, 2), 1, Z_val]);
	[Pz_fit, fval] = fminsearch(G_z, [R(i, 3), 1, Z_val]);
                %[P_total_fit, fval] = fminsearch(G_total, [R(i, 1), R(i, 2), R(i, 3), Z_val, 1]);
                
                %X_fit = [X_fit; Px_fit]; 
                %Y_fit = [Y_fit; Py_fit];
                %Z_fit = [Z_fit; Pz_fit];
                %All_P = [All_P;P_total_fit];
	All_P = [All_P; [Px_fit(1), Py_fit(1), Pz_fit(1), Px_fit(2), Py_fit(2), Pz_fit(2), Px_fit(3), Py_fit(3), Pz_fit(3)]];
                
                %{
                h = figure;
                set(h, 'Position', [400 100 500 900]);
                subplot(3,1,1), hold on, plot(X_mask, X_tmp, 'b', 'linewidth', 2);
                plot([R(i, 1) R(i, 1)], [0 Px_fit(3)], 'b', 'linewidth', 2);
                plot([Px_fit(1) Px_fit(1)], [0 Px_fit(3)], 'r', 'linewidth', 2);
                plot(X_mask, (P_total_fit(4)*exp(-((P_total_fit(1) - X_mask)/P_total_fit(5)).^2)), 'r', 'linewidth', 2);
                plot(X_mask, (Px_fit(3)*exp(-((Px_fit(1) - X_mask)/Px_fit(2)).^2)), 'g', 'linewidth', 2);
                legend('data', 'one sigma fit', 'seperate sigma fit');
                
                subplot(3,1,2), hold on, plot(Y_mask, Y_tmp, 'b', 'linewidth', 2);
                plot([R(i, 2) R(i, 2)], [0 Py_fit(3)], 'b', 'linewidth', 2);
                plot([Py_fit(1) Py_fit(1)], [0 Py_fit(3)], 'r', 'linewidth', 2);
                plot(Y_mask, (P_total_fit(4)*exp(-((P_total_fit(2) - Y_mask)/P_total_fit(5)).^2)), 'r', 'linewidth', 2);
                plot(Y_mask, (Py_fit(3)*exp(-((Py_fit(1) - Y_mask)/Py_fit(2)).^2)), 'g', 'linewidth', 2);
                legend('data', 'one sigma fit', 'seperate sigma fit');
                
                subplot(3,1,3), hold on, plot(Z_mask, Z_tmp, 'b', 'linewidth', 2);
                plot([R(i, 3) R(i, 3)], [0 Pz_fit(3)], 'b', 'linewidth', 2);
                plot([Pz_fit(1) Pz_fit(1)], [0 Pz_fit(3)], 'r', 'linewidth', 2);
                plot(Z_mask, (P_total_fit(4)*exp(-((P_total_fit(3) - Z_mask)/P_total_fit(5)).^2)), 'r', 'linewidth', 2);
                plot(Z_mask, (Pz_fit(3)*exp(-((Pz_fit(1) - Z_mask)/Pz_fit(2)).^2)), 'g', 'linewidth', 2);
                legend('data', 'one sigma fit', 'seperate sigma fit');
                pause(1);
                %}

end



end

