function R_out = pkfnd3_no_cut(Im, th, sz)
%PKFND3 This function takes in the image and find all local maximum's
%withing sz of pixels of intensity higher than th

if abs(floor(sz) - sz) > 0,
    sz = floor(sz);
end
if sz == 0 ,
    error('sz cannot be 0');
    R_out = [];
    return
end

Id_th = find(Im > th); %% find all the points that are larger than th;

%Note Id_th = x + (y-1)*s1 + (z-1)*s1*s2

%disp(size(Id_th));
[s1, s2, s3] = size(Im);
Id_prime = Id_th-1;
Z_th = floor(Id_prime/(s1*s2))+1;
Y_th = floor(mod(Id_prime, s1*s2)/s1)+1;
X_th = mod(Id_prime, s1) +1;
%disp(strcat('s1 = ', num2str(s1), 's2 = ', num2str(s2), 's3 = ', num2str(s3)));

%{
if sum(Id_th == X_th + (Y_th-1)*s1 + (Z_th-1)*s1*s2) == length(Id_th),
    %disp('Indexes Match up');
end

check = 0;
for i=1:length(Id_th),
    if Im(X_th(i), Y_th(i), Z_th(i)) == Im(Id_th(i)),
        check = check+1;
    end
end

if check == length(Id_th),
    %disp('Indexes Match up very well');
end
%}

%[max(max(max(X_th))), max(max(max(Y_th))), max(max(max(Z_th)))]
R_lcl_max = [];

for i=1:length(Z_th),
    x_chk = X_th(i); y_chk = Y_th(i); z_chk = Z_th(i);
    
    if x_chk <= sz,
        idx1 = 1; idx2 = x_chk+sz;
    elseif x_chk >= (s1-sz),
        idx1 = x_chk-sz; idx2 = s1;
    else
        idx1 = x_chk-sz; idx2 = x_chk+sz;
    end
    
    if y_chk <= sz,
        idy1 = 1; idy2 = y_chk+sz;
    elseif y_chk >= (s2-sz),
        idy1 = y_chk-sz; idy2 = s2;
    else
        idy1 = y_chk-sz; idy2 = y_chk+sz;
    end
    
    if z_chk <= sz,
        idz1 = 1; idz2 = z_chk+sz;
    elseif z_chk >= (s3-sz),
        idz1 = z_chk-sz; idz2 = s3;
    else
        idz1 = z_chk-sz; idz2 = z_chk+sz;
    end
    
    Chk_val = Im(x_chk, y_chk, z_chk);
   
   Chk_stack = Im(idx1:idx2, idy1:idy2, idz1:idz2);
   
    if sum(Chk_stack > Chk_val) == 0,
        % If there are no neighborhood points that are higher than the
        % center point then this point is a local maximum
        if x_chk > 1 && x_chk < s1 && y_chk > 1 && y_chk < s2 && z_chk > 1 && z_chk < s3,
            R_lcl_max = [R_lcl_max; [x_chk, y_chk, z_chk]];
        end
    end
    
end
R_out = R_lcl_max;

end

