function [MX_M, MY_M, MZ_M, MX_E, MY_E, MZ_E] = Calc_MSD_XYZ(Traj_in, MSD_len)
MX_M = zeros(1, MSD_len+1);
MY_M = zeros(1, MSD_len+1);
MZ_M = zeros(1, MSD_len+1);

MX_E = zeros(1, MSD_len+1);
MY_E = zeros(1, MSD_len+1);
MZ_E = zeros(1, MSD_len+1);


    for i=1:MSD_len,
        MX_i = []; MY_i = []; MZ_i = [];
        
        for j=1:length(Traj_in),
            if ~isempty(Traj_in{j})
                Traj_cur_X = Traj_in{j}(:, 1);
                Traj_cur_Y = Traj_in{j}(:, 2);
                Traj_cur_Z = Traj_in{j}(:, 3);
                
                % Calculate the MSD (X, Y, Z) for this trajectory
                %This is with resampling
                MX_V = (Traj_cur_X((i+1):end) - Traj_cur_X(1:(end-i))).^2;
                MY_V = (Traj_cur_Y((i+1):end) - Traj_cur_Y(1:(end-i))).^2;
                MZ_V = (Traj_cur_Z((i+1):end) - Traj_cur_Z(1:(end-i))).^2;
                
                % This is with resampling
                %{
                MX_tmp = mean(MX_V);
                MY_tmp = mean(MY_V);
                MZ_tmp = mean(MZ_V);
                %}
                
                % This is without resampling
                %%{
                Mask = [0:1:(size(MX_V, 1)-1)]';
                Mask_ID = (mod(Mask, (i)) == 0);
                MX_tmp = mean(MX_V(Mask_ID));
                MY_tmp = mean(MY_V(Mask_ID));
                MZ_tmp = mean(MZ_V(Mask_ID));
                %}
                
                MX_i = [MX_i;MX_tmp];
                MY_i = [MY_i;MY_tmp];
                MZ_i = [MZ_i;MZ_tmp];
            end
            

        end
        MX_M(i+1) = mean(MX_i); MX_E(i+1) = std(MX_i)/sqrt(length(MX_i));
        MY_M(i+1) = mean(MY_i); MY_E(i+1) = std(MY_i)/sqrt(length(MY_i));
        MZ_M(i+1) = mean(MZ_i); MZ_E(i+1) = std(MZ_i)/sqrt(length(MZ_i));
        
        
    end


end