


void Record_data(double *Xpos, double *Ypos, double *Zpos, int N)
{
	ofstream myfile;
	myfile.open("dataout.m", ios::app);
	int i=0;
	myfile<<"X = [X;[";
	for (i=0; i<N-1; i++) {
		myfile<<Xpos[i]<<", ";
	}
	myfile<<Xpos[N-1]<<"]];"<<endl;
	
	myfile<<"Y = [Y;[";
	for (i=0; i<N-1; i++) {
		myfile<<Ypos[i]<<", ";
	}
	myfile<<Ypos[N-1]<<"]];"<<endl;
	
	myfile<<"Z = [Z;[";
	for (i=0; i<N-1; i++) {
		myfile<<Zpos[i]<<", ";
	}
	myfile<<Zpos[N-1]<<"]];"<<endl;
	
	myfile.close();
}

void Record_Potential(double ***Potential, int NumX, int NumY, int NumZ, double dx, double dy, double dz)
{		
	ofstream* file = new ofstream("Potential.m");
	(*file)<<"dx = "<<dx<<";"<<endl;
	(*file)<<"dy = "<<dy<<";"<<endl;
	(*file)<<"dz = "<<dz<<";"<<endl;
	(*file)<<"V = zeros("<<NumZ<<", "<<NumX<<", "<<NumY<<");"<<endl;
	
	int x, y, z;
	
	for (z=0; z<NumZ; z++) {
		(*file)<<"V_tmp = [];"<<endl;
		for (x=0; x<NumX; x++) {
			(*file)<<"V_tmp = [V_tmp;[";
			for (y=0; y<NumY; y++) {
				(*file)<< Potential[x][y][z] << ", ";
			}
			(*file)<<"]];"<<endl;
		}
		(*file)<<"V("<<z+1<<", :, :) = V_tmp;"<<endl;
	}
	(*file)<<endl<<endl;
	
	file->close();
	delete file;
}


void Record_Init(double dt, double D_step, int N, int t_sample)
{		
	ofstream* file = new ofstream("dataout.m");
	
	(*file)<<"N = "<<N<<";"<<endl;
	(*file)<<"dt = "<<dt<<";"<<endl;
	(*file)<<"t_sample = "<<t_sample<<";"<<endl;
	(*file)<<"D_step = "<<D_step<<";"<<endl;
	(*file)<<"X = [];Y = [];Z = [];"<<endl<<endl<<endl;

	file->close();
	delete file;
}