clear all;close all; clc;
% OLEG POLYAKOV | PRINCETON UNIVERSITY | 2008-2013
fig = figure; % create the figure
winsize = get(fig, 'Position');
winsize(1:2) = [0 0];
numframes = 16;

The_Movie = moviein(numframes, fig, winsize); % Create the movie variable
set(fig,'NextPlot','replacechildren');

N = 1000;


t_sample = 10;
t_max = t_sample*numframes;
count = 1;

X = zeros(N, 1);Y = zeros(N, 1);Z = zeros(N, 1);
dr = .1;
for t = 1:t_max,
    
   X = X + (floor(rand(N, 1)*2)*2 - 1)*dr;
   Y = Y + (floor(rand(N, 1)*2)*2 - 1)*dr;
   Z = Z + (floor(rand(N, 1)*2)*2 - 1)*dr;
   
   if mod(t, t_sample) == 0,
       scatter3(X, Y, Z, 30,  'b', 'filled');axis([-10 10 -10 10 -10 10]); %
       view([-22, 44]);
       title(strcat('Time ', num2str(t)));
       drawnow; pause(.1);
       
       % Now get the frame that is currently in the figure and add it to the
       % movie
       The_Movie(:,count)=getframe;
       count = count + 1;
   end
       
   
    
end


movie(The_Movie,10,3); % Play back the movie
movie2avi(The_Movie, 'My_movie.avi'); % Writes the movie as a avi file

