% OLEG POLYAKOV | PRINCETON UNIVERSITY | 2008-2013
close all; clear all; clc;

%%
V_view;
%%
[s1, s2, s3] = size(V);
[X_G, Y_G, Z_G] = meshgrid(1:s2, 1:s3, 1:s1);
f = find(V > 0);
X_tmp = X_G(f); Y_tmp = Y_G(f); Z_tmp = Z_G(f);
scatter3(X_tmp, Y_tmp, Z_tmp);

%%
disp('Now reading dataout...');
%dataout;
%dataout_MT;
dataout_MT2;
disp('Done');
figure,
%voxel([2, 2, 2], [6,6,6], 'r', .1),
view([22, 16]);hold on;
scatter3(X(1, :), Y(1, :), Z(1, :), 50, 'b', 'filled');
X_min = min(X(end, :)); X_max = max(X(end, :));
Y_min = min(Y(end, :)); Y_max = max(Y(end, :));
Z_min = min(Z(end, :)); Z_max = max(Z(end, :));
axis([X_min, X_max, Y_min, Y_max, Z_min, Z_max]);
drawnow, pause(.2);
h = get(gca, 'children');

for i=1:size(X, 1),
    set(h(1), 'xdata', X(i, :));
    set(h(1), 'ydata', Y(i, :));
    set(h(1), 'zdata', Z(i, :));
    title(strcat('Time = ', num2str(i)));
    pause(.3);
end
%%
disp('Now reading dataout...');
dataout;
%dataout_MT;
%dataout_MT2;
disp('Done');
Traj_SIM = cell(1,1);
T_V = [0:dt*t_sample:(size(X, 1)-1)*dt*t_sample];
for i=1:size(X, 2),
    Traj_SIM{i} = [X(:, i), Y(:, i), Z(:, i)];
end
[MSD_XM, MSD_YM, MSD_ZM, MSD_XE, MSD_YE, MSD_ZE] = Calc_MSD_XYZ(Traj_SIM, 50); 
%%
%figure, hold on;
title('MSD from the trajectories');
errorbar(T_V(1:length(MSD_XM)), MSD_XM, MSD_XE, 'g', 'linewidth', 3);
errorbar(T_V(1:length(MSD_YM)), MSD_YM, MSD_YE, 'g', 'linewidth', 3);
errorbar(T_V(1:length(MSD_ZM)), MSD_ZM, MSD_ZE, 'r');

    